import java.awt.*;
import java.awt.image.*;
import java.awt.Graphics;
import java.io.*;
import java.util.*;
import javax.swing.*;
import java.awt.event.*;
import java.awt.geom.Rectangle2D;

import javax.swing.JApplet;

public class PrelimApp extends JApplet
{
	String fileNames[] = {"008a013s00L_0078o.png","008a013s00L_0084o.png","010a022s00L_0070o.png","008e013s00L_0054o.png"};
	String sfileNames[] = {"008a013s00L_0078.png","008a013s00L_0084.png","010a022s00L_0070.png","008e013s00L_0054.png"};
	String transitions = new String("     Initial Image     >>     Background Subtracted Image     >>     Cropped Image     >>     Scaled Image");  
	public PrelimApp()
	{
		fileNum=0;
		fileName = "008a013s00L_0078o.png";
		sfileName = "008a013s00L_0078.png";
	}

	void fillshape(int[] input, int[] processed, int[] areas, int X, int Y, int value){
		//set this processed value
		processed[Y*width+X]=value;
		areas[value]++;
		if(X<width-1 && input[Y*width+X+1]!=-16777216 && processed[Y*width+X+1]==0){
			fillshape(input, processed, areas, X+1, Y, value);
		}
		if(X>1 && input[Y*width+X-1]!=-16777216 && processed[Y*width+X-1]==0){
			fillshape(input, processed, areas, X-1, Y, value);
		}
		if(Y<height-1 && input[(Y+1)*width+X]!=-16777216 && processed[(Y+1)*width+X]==0){
			fillshape(input, processed, areas, X, Y+1, value);
		}
		if(Y>1 && input[(Y-1)*width+X]!=-16777216 && processed[(Y-1)*width+X]==0){
			fillshape(input, processed, areas, X, Y-1, value);
		}

		return;
	}
	//returns new image, and updates width and height variables
	private int[] cropImage(int[] input) {

		int[] output = new int[4];

		int[] processed = new int[width*height];

		int[] areas  = new int[width*height];

		int index=0;

		for(int x=0; x<width;x++) {
			for(int y=0; y<height;y++) {
				processed[y*width+x]=0;
				areas[y*width+x]=0;
			}
		}

		int max=0, maxIndex=0;
		for(int x=0; x<width;x++) {
			for(int y=0; y<height;y++) {
				if(input[y*width+x]!=-16777216 && processed[y*width+x]==0){
					index++;
					fillshape(input, processed, areas, x, y, index);
					if(max<areas[index]){
						max=areas[index];
						maxIndex=index;
					}
				}
			}
		}
		System.out.println("Largest area: "+ maxIndex+" val: "+max);

		int Xmin=width, Xmax=0, Ymin=height, Ymax=0;

		for(int x=0; x<width;x++) {
			for(int y=0; y<height;y++) {
				if(processed[y*width+x]==maxIndex){
					if(x<Xmin)
						Xmin=x;
					if(y<Ymin)
						Ymin=y;
					if(x>Xmax)
						Xmax=x;
					if(y>Ymax)
						Ymax=y;
				}
			}
		}

		Xmin=Xmin-1;
		Xmax=Xmax+2;
		Ymin=Ymin-1;
		Ymax=Ymax+2;

		//int oldWidth=width, oldHeight=height;

		//update new width and height info
		croppedW=Xmax-Xmin;						
		croppedH=Ymax-Ymin;

		int[] cropData = new int[croppedW*croppedH];

		//System.out.println("cropping to: "+ Xmin+" "+Xmax+" "+Ymin+" "+Ymax);

		for(int x=0; x<croppedW; x++) {
			for(int y=0; y<croppedH; y++) {
				if(processed[(y+Ymin)*width+(x+Xmin)]==maxIndex)
					cropData[y*croppedW+x]=input[(y+Ymin)*width+(x+Xmin)];
				else
					cropData[y*croppedW+x]=-16777216;
			}
		}

		return cropData;
	}
	
	public void init()
	{
		setBackground(Color.WHITE);

		imagePanel = new JPanel();
		imagePanel.setBackground(Color.WHITE);
		controlPanel = new JPanel();
		controlPanel.setBackground(Color.WHITE);
		getContentPane().add(imagePanel, BorderLayout.NORTH);
		getContentPane().add(controlPanel, BorderLayout.CENTER);

		Image imagec = getImage(getCodeBase(), fileName);
		width = imagec.getWidth(new JLabel(new ImageIcon(imagec)));
		height = imagec.getHeight(new JLabel(new ImageIcon(imagec)));
		width = width;
		height = height;
		imagec = imagec.getScaledInstance(width, height, Image.SCALE_DEFAULT); 
		Image image = getImage(getCodeBase(), sfileName);
		image = image.getScaledInstance(width, height, Image.SCALE_DEFAULT) ;
		imagecLabel = new JLabel(new ImageIcon(imagec));
		imageLabel = new JLabel(new ImageIcon(image));

		pixels = new int[width * height];
		try {
			PixelGrabber pg = new PixelGrabber(image, 0, 0, width, height, pixels, 0, width);
			pg.grabPixels();
		} catch(Exception e) { }

		int[] temppixels = pixels;
		croppedpixels = cropImage(temppixels);
		croppedimage = createImage(new MemoryImageSource(croppedW, croppedH, croppedpixels, 0, croppedW));
		croppedimgLabel = new JLabel(new ImageIcon(croppedimage));
		int scaledWidth = 64*croppedW/croppedH;
	/*	if (croppedW>croppedH){
			int newheight=(int)(64*((float)(croppedH)/(float)(croppedW)));
			scaledimage = croppedimage.getScaledInstance(64,newheight, BufferedImage.SCALE_DEFAULT);
			scaledimage2 = new BufferedImage(64, 64, BufferedImage.TYPE_INT_ARGB);
			Graphics2D imageGraphics = scaledimage2.createGraphics();
			imageGraphics.setColor(Color.black);
			imageGraphics.fill(new Rectangle2D.Float(0, 0, 64, 64));
			imageGraphics.drawImage(scaledimage, 0, (int)((64-newheight)/2), null);
		}
		else if(croppedW<croppedH){
			int newwidth=(int)(64*((float)croppedW/(float)croppedH));
			scaledimage = croppedimage.getScaledInstance(newwidth,64, BufferedImage.SCALE_DEFAULT);
			scaledimage2 = new BufferedImage(64, 64, BufferedImage.TYPE_INT_ARGB);
			Graphics2D imageGraphics = scaledimage2.createGraphics();
			imageGraphics.setColor(Color.black);
			imageGraphics.fill(new Rectangle2D.Float(0, 0, 64, 64));
			imageGraphics.drawImage(scaledimage, (int)((64-newwidth)/2), 0, null);
		}
		if (croppedW!=croppedH){
			scaledimage=Toolkit.getDefaultToolkit().createImage(scaledimage2.getSource());
		}*/
		scaledimage = croppedimage.getScaledInstance(scaledWidth,64, BufferedImage.SCALE_DEFAULT);
		scaledimage2 = new BufferedImage(64, 64, BufferedImage.TYPE_INT_ARGB);
		Graphics2D imageGraphics = scaledimage2.createGraphics();
		imageGraphics.setColor(Color.black);
		imageGraphics.fill(new Rectangle2D.Float(0, 0, 64, 64));
		imageGraphics.drawImage(scaledimage, (int)((64-scaledWidth)/2), 0, null);
		scaledimgLabel=new JLabel(new ImageIcon(scaledimage2));
		
		final JComboBox imageType = new JComboBox();		
		imageLab = new JLabel("  Image: ");
		transitionsLab = new JLabel("     Initial Image     >>     Background Subtracted Image     >>     Cropped Image     >>     Scaled Image");  

		ActionListener al = new ActionListener()
		{
			public void actionPerformed(ActionEvent event)
			{

				long size = width * height;
				if(imageType.getSelectedItem().equals("Stride")) fileNum=0;
				else if(imageType.getSelectedItem().equals("Straight")) fileNum=1;
				else if(imageType.getSelectedItem().equals("Short")) fileNum=2;
				else if(imageType.getSelectedItem().equals("Outdoors")) fileNum=3;
				refreshImage();
				
			}
		};
		
		imageType.addItem("Stride");
		imageType.addItem("Straight");
		imageType.addItem("Short");
		imageType.addItem("Outdoors");
		imageType.setSelectedIndex(0);
		imageType.addActionListener(al);
		
		imagePanel.add(imagecLabel);
		imagePanel.add(imageLabel);
		imagePanel.add(croppedimgLabel);
		imagePanel.add(scaledimgLabel);
		controlPanel.add(imageLab);
		controlPanel.add(imageType);
		controlPanel.add(transitionsLab);

		
	}
	public void refreshImage(){
		updateImage();
		// This fixes the imaging problem
		setEnabled(false);
		validate();
		setEnabled(true);
		repaint();
	}

	// Gets the pixel data into the pixels array
	public void updateImage()
	{
		fileName=fileNames[fileNum];
		sfileName=sfileNames[fileNum];
		JLabel imageLabelTemp=imageLabel;
		JLabel imagecLabelTemp=imagecLabel;
		JLabel croppedimgLabelTemp=croppedimgLabel;
		JLabel scaledimgLabelTemp=scaledimgLabel;		
	
		Image imagec = getImage(getCodeBase(), fileName);
		width = imagec.getWidth(new JLabel(new ImageIcon(imagec)));
		height = imagec.getHeight(new JLabel(new ImageIcon(imagec)));
		width = width;
		height = height;
		imagec = imagec.getScaledInstance(width, height, Image.SCALE_DEFAULT); 
		Image image = getImage(getCodeBase(), sfileName);
		image = image.getScaledInstance(width, height, Image.SCALE_DEFAULT);
		imagecLabel = new JLabel(new ImageIcon(imagec));
		imageLabel = new JLabel(new ImageIcon(image));

		pixels = new int[width * height];
		try {
			PixelGrabber pg = new PixelGrabber(image, 0, 0, width, height, pixels, 0, width);
			pg.grabPixels();
		} catch(Exception e) { }

		int[] temppixels = pixels;
		croppedpixels = cropImage(temppixels);
		croppedimage = createImage(new MemoryImageSource(croppedW, croppedH, croppedpixels, 0, croppedW));
		croppedimgLabel = new JLabel(new ImageIcon(croppedimage));
		int scaledWidth = 64*croppedW/croppedH;
	/*	if (croppedW>croppedH){
			int newheight=(int)(64*((float)(croppedH)/(float)(croppedW)));
			scaledimage = croppedimage.getScaledInstance(64,newheight, BufferedImage.SCALE_DEFAULT);
			scaledimage2 = new BufferedImage(64, 64, BufferedImage.TYPE_INT_ARGB);
			Graphics2D imageGraphics = scaledimage2.createGraphics();
			imageGraphics.setColor(Color.black);
			imageGraphics.fill(new Rectangle2D.Float(0, 0, 64, 64));
			imageGraphics.drawImage(scaledimage, 0, (int)((64-newheight)/2), null);
		}
		else if(croppedW<croppedH){
			int newwidth=(int)(64*((float)croppedW/(float)croppedH));
			scaledimage = croppedimage.getScaledInstance(newwidth,64, BufferedImage.SCALE_DEFAULT);
			scaledimage2 = new BufferedImage(64, 64, BufferedImage.TYPE_INT_ARGB);
			Graphics2D imageGraphics = scaledimage2.createGraphics();
			imageGraphics.setColor(Color.black);
			imageGraphics.fill(new Rectangle2D.Float(0, 0, 64, 64));
			imageGraphics.drawImage(scaledimage, (int)((64-newwidth)/2), 0, null);
		}
		if (croppedW!=croppedH){
			scaledimage=Toolkit.getDefaultToolkit().createImage(scaledimage2.getSource());
		}*/
		scaledimage = croppedimage.getScaledInstance(scaledWidth,64, BufferedImage.SCALE_DEFAULT);
		scaledimage2 = new BufferedImage(64, 64, BufferedImage.TYPE_INT_ARGB);
		Graphics2D imageGraphics = scaledimage2.createGraphics();
		imageGraphics.setColor(Color.black);
		imageGraphics.fill(new Rectangle2D.Float(0, 0, 64, 64));
		imageGraphics.drawImage(scaledimage, (int)((64-scaledWidth)/2), 0, null);
		scaledimgLabel=new JLabel(new ImageIcon(scaledimage2));

		imagePanel.remove(imagecLabelTemp);
		imagePanel.remove(imageLabelTemp);
		imagePanel.remove(croppedimgLabelTemp);
		imagePanel.remove(scaledimgLabelTemp);

		imagePanel.add(imagecLabel);
		imagePanel.add(imageLabel);
		imagePanel.add(croppedimgLabel);
		imagePanel.add(scaledimgLabel);
	}


	int width, height, fileNum, croppedW, croppedH;
	int[] pixels, croppedpixels;

	Image image, croppedimage, scaledimage;
	BufferedImage scaledimage2;
	JPanel imagePanel, controlPanel;
	
	JLabel imagecLabel, imageLab, transitionsLab, imageLabel, croppedimgLabel, scaledimgLabel;
	String fileName, sfileName;

}
